-- 30.1.2011 nyni scandoubler pracuje s dolni polovinou datove sbernice (prepsal VELESOFT)
-----------------------------------------------------------------------------------------------------------------------
-- 4.9.2010 oprava v synchronizaci zapisu
-- pridan register zxADR pro zapamatovani adresy pameti kvuli stabilite pri zapisu
-- kosmeticka uprava oznaceni vstupnich signalu !!!!!! POZOR POUZIT NOVY zxvga.ucf !!!!!!
-----------------------------------------------------------------------------------------------------------------------
-- 11.7.2010 opravena starsi stabilni verze bez vad v obraze (opravil VELESOFT)
-- Nove napsane signaly VGA_IB,iVGA_IR a iVGA_IG pro spravny BRIGHT
-----------------------------------------------------------------------------------------------------------------------


library IEEE;
use IEEE.std_logic_1164.ALL;
use IEEE.std_logic_arith.ALL;
use IEEE.std_logic_unsigned.ALL;
entity ZXVGA is port (
-----------------------------------------------------------------------------------------------------------------------
--vnejsi piny pro pripojeni k ZX---------------------------------------------------------------------------------------
ZX_CLK	: in std_logic;						--hodiny od zx 35,469 MHz
ZX_RGBI	: in std_logic_vector(3 downto 0);			--barvy od zx R=0,G=1,B=2,I=3
ZX_CSYC	: in std_logic;						--synchronizace od zx
-----------------------------------------------------------------------------------------------------------------------
--vnejsi piny pro pripojeni k externi RAM------------------------------------------------------------------------------
RAM_AD	: out std_logic_vector(17 downto 0);			--adresa k RAM
RAM_DT	: inout std_logic_vector(15 downto 0);			--datova sbernice RAM
RAM_WR	: out std_logic;					--povoleni zapisu do RAM
-----------------------------------------------------------------------------------------------------------------------
--vnejsi piny pro pripojeni k VGA--------------------------------------------------------------------------------------
VGA_CLK	: in std_logic;						--hodiny 25 MHz
VGA_R	: out std_logic;					--vga vystup cervena slozka
VGA_G	: out std_logic;					--vga vystup zelena slozka
VGA_B	: out std_logic;					--vga vystup modra slozka
VGA_IR1	: out std_logic;					--vga vystup intenzita cervene slozky
VGA_IR2	: out std_logic;					--vga vystup intenzita cervene slozky
VGA_IG1	: out std_logic;					--vga vystup intenzita zelene slozky
VGA_IG2	: out std_logic;					--vga vystup intenzita
VGA_IB	: out std_logic;					--vga vystup intenzita
VGA_HS	: out std_logic;					--vga vystup horizontalni synchronizace
VGA_VS	: out std_logic);					--vga vystup vertikalni synchronizace
-----------------------------------------------------------------------------------------------------------------------
end ZXVGA;
architecture rtl of ZXVGA is
-----------------------------------------------------------------------------------------------------------------------
--vnitrni signaly pro casovani ZX synchronizace------------------------------------------------------------------------
--signal iRGBI	: std_logic_vector(3 downto 0);			--vstupni RGBI
signal rZX_CSYC	: std_logic;					--pamet stavu synchronizace od zx v minulem CLK
signal zxDIV5	: std_logic_vector(2 downto 0);			--zx citac pro deleni 5
signal zxCTCH	: std_logic_vector(8 downto 0);			--zx horizontalni citac
signal zxCTCV	: std_logic_vector(8 downto 0);			--zx vertikalni citac
signal rZXDT4	: std_logic_vector(3 downto 0);			--register jednoho pixelu od zx
signal rZXDT8	: std_logic_vector(7 downto 0);			--register dvou pixelu od zx
signal zxPAGE	: std_logic;					--vyber stranky do ktere se zapisuje
signal zxADR	: std_logic_vector(7 downto 0);			--register adresy pro pamet ram
-----------------------------------------------------------------------------------------------------------------------
--vnitrni signaly pro synchronizaci zapisu-----------------------------------------------------------------------------
signal iRAM_WR	: std_logic;					--interni signal /WR pro pamet RAM
signal rWRREQ	: std_logic;					--pamet stavu zxCTCH(0) v minulem CLK
signal pWRREQ	: std_logic;					--pamet pozadavku zapisu
-----------------------------------------------------------------------------------------------------------------------
--vnitrni signaly pro casovani VGA-------------------------------------------------------------------------------------
signal vgaDIV	: std_logic;					--delicka kmitoctu
signal vgaPAGE	: std_logic;					--vyber stranky ze ktere se zobrazuje
signal vgaCTCH	: std_logic_vector(9 downto 0);			--VGA horizontalni citac
signal vgaCTCV	: std_logic_vector(9 downto 0);			--VGA vertikalni citac
signal vgaENA	: std_logic;					--povoleni zobrazovani
signal vgaENv	: std_logic;					--povoleni zobrazovani od vertikalniho citace
signal rPIXEL	: std_logic_vector(7 downto 0);			--register dat z pameti (dvou pixelu)
signal iVGA_IR	: std_logic;					--pomocna intenzita cervene slozky
signal iVGA_IG	: std_logic;					--pomocna intenzita modre slozky
-----------------------------------------------------------------------------------------------------------------------
begin
process (ZX_CLK) begin
    if ZX_CLK'event and ZX_CLK='0' then
-----------------------------------------------------------------------------------------------------------------------
--citace a synchronizace dat od ZX-------------------------------------------------------------------------------------
	rZX_CSYC <= ZX_CSYC;					--pamet stavu csync od zx v minulem cyklu
	zxDIV5 <= zxDIV5 + '1';					--citac delicky kmitoctu +1
	if rZX_CSYC='1' and ZX_CSYC='0' then			--detekovana sestupna hrana synchronizace
	    zxDIV5 <= (others=>'0');				--inicializace delicky kmitoctu
	    zxCTCH <= "110011100";				--inicializace horizontalniho citace (zmenou hotnoty mozno posouvat obraz vlevo/vpravo)
	    zxCTCV <= zxCTCV + '1';				--vertikalni citac +1
	    if zxCTCV=239 then
		zxPAGE <= not zxPAGE;				--zmena zapisove stranky
	    end if;
	elsif zxDIV5=4 then
	    zxDIV5 <= (others=>'0');				--inicializace delicky kmitoctu
	    zxCTCH <= zxCTCH + '1';				--horizontalni citac +1
	    if zxCTCH(0)='0' then
		rZXDT4 <= ZX_RGBI;				--registruj prvni pixel
	    else 
		rZXDT8 <= ZX_RGBI & rZXDT4;			--registruj dva pixely
		zxADR <= zxCTCH(8 downto 1);			--pridano 4.9.2010 zapamatuje si stav zxCTCH pro adresaci pameti
	    end if;
	end if;
	if zxCTCH=256 and rZX_CSYC='0' then			--pokud nekde uprostred radku trva sync
	    zxCTCV <= "111011101";				--inicializace vertikalniho citace (zmenou hotnoty mozno posouvat obraz nahoru/dolu)
	end if;
-----------------------------------------------------------------------------------------------------------------------
    end if;
end process;
process (VGA_CLK) begin
    if VGA_CLK'event and VGA_CLK='0' then
    vgaDIV <= not vgaDIV;					--delicka kmitoctu
    if vgaDIV='0' then
-----------------------------------------------------------------------------------------------------------------------
--generovani signalu WR pro pamet RAM----------------------------------------------------------------------------------
	iRAM_WR <= '1';						--zapis je defaultne neaktivni
	pWRREQ <= '0';						--pamet pozadavku zapisu je defaultne neaktivni
								--detekce pozadavku o zapis (sestupna hrana signalu zxCTCH(0)) nebo pamet pozadavku zapisu
	if (zxCTCH(0)='0' and rWRREQ='1' and zxCTCV(8)='0') or pWRREQ='1' then
	    if vgaCTCH(1 downto 0)="10" then			--pokud bude nasledovat cteni z RAM
		pWRREQ <= '1';					--zapis nemuze byt vykonan nastavi se pamet pozadavku zapisu
	    else
		iRAM_WR <= '0';					--nastav signal /WR
	    end if;
	end if;
	rWRREQ <= zxCTCH(0);					--kopirovani stavu zxCTCH(0)
-----------------------------------------------------------------------------------------------------------------------
--VGA - citani, nulovani horizontalniho a vertikalniho citace----------------------------------------------------------
	if vgaCTCH=798 then					--pokud jsme docitali sloupce na radku
	    vgaCTCH <= (others=>'0');				--nulovani horizontalniho citace
	    if vgaCTCV=524 then					--pokud jsme docitali radky na strance
		vgaCTCV <= (others=>'0');			--nulovani vertikalniho citace
	    else
		vgaCTCV <= vgaCTCV + '1';			--vertikalni citac +1
	    end if;
	else
	    vgaCTCH <= vgaCTCH + '1';				--horizontalni citac +1
	end if;
-----------------------------------------------------------------------------------------------------------------------
--VGA - generovani vertikalni synchronizace----------------------------------------------------------------------------
	if vgaCTCV=0 then
	    vgaENv <= '1';					--povoleni zobrazeni
	elsif vgaCTCV=480 then
	    vgaENv <= '0';					--zakazani zobrazeni
	elsif vgaCTCV=490 then
	    VGA_VS <= '0';					--zacatek vertikalni synchronizace
	elsif vgaCTCV=492 then
	    VGA_VS <= '1';					--konec vertikalni synchronizace
	    vgaPAGE <= not zxPAGE;				--zobrazuje se stranka do ktere se nezapisuje
	end if;
-----------------------------------------------------------------------------------------------------------------------
--VGA - generovani horizontalni synchronizace--------------------------------------------------------------------------
	if vgaCTCH=3 and vgaENv='1' then
	    vgaENA <= '1';					--povoleni zobrazovani
	elsif vgaCTCH=643 then
	    vgaENA <= '0';					--zakazani zobrazovani
	elsif vgaCTCH=659 then
	    VGA_HS <= '0';					--zacatek horizontalni synchronizace
	elsif vgaCTCH=755 then
	    VGA_HS <= '1';					--konec horizontalni synchronizace
	end if;
-----------------------------------------------------------------------------------------------------------------------
--VGA - zapis prectenych dat z pameti do registru----------------------------------------------------------------------
	if vgaCTCH(1 downto 0)="11" then
	    rPIXEL <= RAM_DT(7 downto 0);			--zapis prectenych dat z pameti do registru
	end if;
-----------------------------------------------------------------------------------------------------------------------
    end if;
    end if;
end process;
-----------------------------------------------------------------------------------------------------------------------
--VGA - generovani barvonosnych signalu--------------------------------------------------------------------------------
VGA_R <=	'0' when vgaENA='0' else			--zobrazovani zakazano
		rPIXEL(0) when vgaCTCH(1)='0' else  		--prvni pixel v bajtu
		rPIXEL(4);  					--druhy pixel v bajtu
VGA_G <=	'0' when vgaENA='0' else
		rPIXEL(1) when vgaCTCH(1)='0' else
		rPIXEL(5);
VGA_B <=	'0' when vgaENA='0' else
		rPIXEL(2) when vgaCTCH(1)='0' else
		rPIXEL(6);

-- opravene signaly VGA_IB,iVGA_IR a iVGA_IG (VELESOFT 11.7.2010 - 10:55)
-- ted se bright aplikuje jen u slozek R,G a B (cerna barva je vzdy cerna)
iVGA_IR <=	'0' when vgaENA='0' else
		rPIXEL(3) and rPIXEL(0) when vgaCTCH(1)='0' else
		rPIXEL(7) and rPIXEL(4);
iVGA_IG  <=	'0' when vgaENA='0' else
		rPIXEL(3) and rPIXEL(1) when vgaCTCH(1)='0' else
		rPIXEL(7) and rPIXEL(5);
VGA_IB  <=	'0' when vgaENA='0' else
		rPIXEL(3) and rPIXEL(2) when vgaCTCH(1)='0' else
		rPIXEL(7) and rPIXEL(6);

VGA_IR1 <= iVGA_IR;
VGA_IR2 <= iVGA_IR;
VGA_IG1 <= iVGA_IG;
VGA_IG2 <= iVGA_IG;
-----------------------------------------------------------------------------------------------------------------------
--napojeni pameti RAM--------------------------------------------------------------------------------------------------
RAM_AD <= '0' & vgaPAGE & vgaCTCV(8 downto 1) & vgaCTCH(9 downto 2) when vgaCTCH(1 downto 0)="11" else
	  '0' & zxPAGE & zxCTCV(7 downto 0) & zxADR;
RAM_DT(7 downto 0) <= rZXDT8 when iRAM_WR='0' else "ZZZZZZZZ";
RAM_DT(15 downto 8) <= "ZZZZZZZZ";
RAM_WR <= iRAM_WR;
-----------------------------------------------------------------------------------------------------------------------
end rtl;